Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.2
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.lang
Class Class

    java.lang.Object
      java.lang.Class

All Implemented Interfaces:
  Serializable

public final class Class
extends Object
implements Serializable

Instances of the class `Class` represent classes and interfaces in a running Java application. Every array also belongs to a class that is reflected as a `Class` object that is shared by all arrays with the same element type and number of dimensions. The primitive Java types (`boolean`, `byte`, `char`, `short`, `int`, `long`, `float`, and `double`), and the keyword `void` are also represented as `Class` objects.

`Class` has no public constructor. Instead `Class` objects are constructed automatically by the Java Virtual Machine as classes are loaded and by calls to the `defineClass` method in the class loader.

The following example uses a `Class` object to print the class name of an object:

>          void printClassName(Object obj) {
>              System.out.println("The class of " + obj +
>                                 " is " + obj.getClass().getName());
>          }

It is also possible to get the `Class` object for a named type (or for void) using a class literal (JLS Section 15.8.2). For example:

>          System.out.println("The name of class Foo is: "+Foo.class.getName());

Since:
  JDK1.0
See Also:
  `ClassLoader.defineClass(byte[], int, int)`, Serialized Form

Method Summary
`boolean` | `desiredAssertionStatus()` Returns the assertion status that would be assigned to this class if it were to be initialized at the time this method is invoked.
`static Class` | `forName(String className)` Returns the `Class` object associated with the class or interface with the given string name.
`static Class` | `forName(String name, boolean initialize, ClassLoader loader)` Returns the `Class` object associated with the class or interface with the given string name, using the given class loader.
`Class[]` | `getClasses()` Returns an array containing `Class` objects representing all the public classes and interfaces that are members of the class represented by this `Class` object.
`ClassLoader` | `getClassLoader()` Returns the class loader for the class.
`Class` | `getComponentType()` Returns the `Class` representing the component type of an array.
`Constructor` | `getConstructor(Class[] parameterTypes)` Returns a `Constructor` object that reflects the specified public constructor of the class represented by this `Class` object.
`Constructor[]` | `getConstructors()` Returns an array containing `Constructor` objects reflecting all the public constructors of the class represented by this `Class` object.
`Class[]` | `getDeclaredClasses()` Returns an array of `Class` objects reflecting all the classes and interfaces declared as members of the class represented by this `Class` object.
`Constructor` | `getDeclaredConstructor(Class[] parameterTypes)` Returns a `Constructor` object that reflects the specified constructor of the class or interface represented by this `Class` object.
`Constructor[]` | `getDeclaredConstructors()` Returns an array of `Constructor` objects reflecting all the constructors declared by the class represented by this `Class` object.
`Field` | `getDeclaredField(String name)` Returns a `Field` object that reflects the specified declared field of the class or interface represented by this `Class` object.
`Field[]` | `getDeclaredFields()` Returns an array of `Field` objects reflecting all the fields declared by the class or interface represented by this `Class` object.
`Method` | `getDeclaredMethod(String name, Class[] parameterTypes)` Returns a `Method` object that reflects the specified declared method of the class or interface represented by this `Class` object.
`Method[]` | `getDeclaredMethods()` Returns an array of `Method` objects reflecting all the methods declared by the class or interface represented by this `Class` object.
`Class` | `getDeclaringClass()` If the class or interface represented by this `Class` object is a member of another class, returns the `Class` object representing the class in which it was declared.
`Field` | `getField(String name)` Returns a `Field` object that reflects the specified public member field of the class or interface represented by this `Class` object.
`Field[]` | `getFields()` Returns an array containing `Field` objects reflecting all the accessible public fields of the class or interface represented by this `Class` object.
`Class[]` | `getInterfaces()` Determines the interfaces implemented by the class or interface represented by this object.
`Method` | `getMethod(String name, Class[] parameterTypes)` Returns a `Method` object that reflects the specified public member method of the class or interface represented by this `Class` object.
`Method[]` | `getMethods()` Returns an array containing `Method` objects reflecting all the public member methods of the class or interface represented by this `Class` object, including those declared by the class or interface and and those inherited from superclasses and superinterfaces.
`int` | `getModifiers()` Returns the Java language modifiers for this class or interface, encoded in an integer.
`String` | `getName()` Returns the name of the entity (class, interface, array class, primitive type, or void) represented by this `Class` object, as a `String`.
`Package` | `getPackage()` Gets the package for this class.
`ProtectionDomain` | `getProtectionDomain()` Returns the `ProtectionDomain` of this class.
`URL` | `getResource(String name)` Finds a resource with a given name.
`InputStream` | `getResourceAsStream(String name)` Finds a resource with a given name.
`Object[]` | `getSigners()` Gets the signers of this class.
`Class` | `getSuperclass()` Returns the `Class` representing the superclass of the entity (class, interface, primitive type or void) represented by this `Class`.
`boolean` | `isArray()` Determines if this `Class` object represents an array class.
`boolean` | `isAssignableFrom(Class cls)` Determines if the class or interface represented by this `Class` object is either the same as, or is a superclass or superinterface of, the class or interface represented by the specified `Class` parameter.
`boolean` | `isInstance(Object obj)` Determines if the specified `Object` is assignment-compatible with the object represented by this `Class`.
`boolean` | `isInterface()` Determines if the specified `Class` object represents an interface type.
`boolean` | `isPrimitive()` Determines if the specified `Class` object represents a primitive type.
`Object` | `newInstance()` Creates a new instance of the class represented by this `Class` object.
`String` | `toString()` Converts the object to a string.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Method Detail

### toString

    public String toString()

  Converts the object to a string. The string representation is the string "class" or "interface", followed by a space, and then by the fully qualified name of the class in the format returned by `getName`. If this `Class` object represents a primitive type, this method returns the name of the primitive type. If this `Class` object represents void this method returns "void".

  Overrides:
    `toString` in class `Object`
  Returns:
    a string representation of this class object.

### forName

    public static Class forName(String className)
                         throws ClassNotFoundException

  Returns the `Class` object associated with the class or interface with the given string name. Invoking this method is equivalent to:

  >       Class.forName(className, true, currentLoader)

  where `currentLoader` denotes the defining class loader of the current class.

  For example, the following code fragment returns the runtime `Class` descriptor for the class named `java.lang.Thread`:

  >        Class t = Class.forName("java.lang.Thread")

  A call to `forName("X")` causes the class named `X` to be initialized.

  Parameters:
    `className` - the fully qualified name of the desired class.
  Returns:
    the `Class` object for the class with the specified name.
  Throws:
    `LinkageError` - if the linkage fails
    `ExceptionInInitializerError` - if the initialization provoked by this method fails
    `ClassNotFoundException` - if the class cannot be located

### forName

    public static Class forName(String name,
                                boolean initialize,
                                ClassLoader loader)
                         throws ClassNotFoundException

  Returns the `Class` object associated with the class or interface with the given string name, using the given class loader. Given the fully qualified name for a class or interface (in the same format returned by `getName`) this method attempts to locate, load, and link the class or interface. The specified class loader is used to load the class or interface. If the parameter `loader` is null, the class is loaded through the bootstrap class loader. The class is initialized only if the `initialize` parameter is `true` and if it has not been initialized earlier.

  If `name` denotes a primitive type or void, an attempt will be made to locate a user-defined class in the unnamed package whose name is `name`. Therefore, this method cannot be used to obtain any of the `Class` objects representing primitive types or void.

  If `name` denotes an array class, the component type of the array class is loaded but not initialized.

  For example, in an instance method the expression:

  >       Class.forName("Foo")

  is equivalent to:

  >       Class.forName("Foo", true, this.getClass().getClassLoader())

  Note that this method throws errors related to loading, linking or initializing as specified in Sections 12.2, 12.3 and 12.4 of The Java Language Specification. Note that this method does not check whether the requested class is accessible to its caller.

  If the `loader` is `null`, and a security manager is present, and the caller's class loader is not null, then this method calls the security manager's `checkPermission` method with a `RuntimePermission("getClassLoader")` permission to ensure it's ok to access the bootstrap class loader.

  Parameters:
    `name` - fully qualified name of the desired class
    `initialize` - whether the class must be initialized
    `loader` - class loader from which the class must be loaded
  Returns:
    class object representing the desired class
  Throws:
    `LinkageError` - if the linkage fails
    `ExceptionInInitializerError` - if the initialization provoked by this method fails
    `ClassNotFoundException` - if the class cannot be located by the specified class loader
  Since:
    1.2
  See Also:
    `forName(String)`, `ClassLoader`

### newInstance

    public Object newInstance()
                       throws InstantiationException,
                              IllegalAccessException

  Creates a new instance of the class represented by this `Class` object. The class is instantiated as if by a `new` expression with an empty argument list. The class is initialized if it has not already been initialized.

  If there is a security manager, this method first calls the security manager's `checkMemberAccess` method with `this` and `Member.PUBLIC` as its arguments. If the class is in a package, then this method also calls the security manager's `checkPackageAccess` method with the package name as its argument. Either of these calls could result in a SecurityException.

  Returns:
    a newly allocated instance of the class represented by this object.
  Throws:
    `IllegalAccessException` - if the class or its nullary constructor is not accessible.
    `InstantiationException` - if this `Class` represents an abstract class, an interface, an array class, a primitive type, or void; or if the class has no nullary constructor; or if the instantiation fails for some other reason.
    `ExceptionInInitializerError` - if the initialization provoked by this method fails.
    `SecurityException` - if there is no permission to create a new instance.

### isInstance

    public boolean isInstance(Object obj)

  Determines if the specified `Object` is assignment-compatible with the object represented by this `Class`. This method is the dynamic equivalent of the Java language `instanceof` operator. The method returns `true` if the specified `Object` argument is non-null and can be cast to the reference type represented by this `Class` object without raising a `ClassCastException.` It returns `false` otherwise.

  Specifically, if this `Class` object represents a declared class, this method returns `true` if the specified `Object` argument is an instance of the represented class (or of any of its subclasses); it returns `false` otherwise. If this `Class` object represents an array class, this method returns `true` if the specified `Object` argument can be converted to an object of the array class by an identity conversion or by a widening reference conversion; it returns `false` otherwise. If this `Class` object represents an interface, this method returns `true` if the class or any superclass of the specified `Object` argument implements this interface; it returns `false` otherwise. If this `Class` object represents a primitive type, this method returns `false`.

  Parameters:
    `obj` - the object to check
  Returns:
    true if `obj` is an instance of this class
  Since:
    JDK1.1

### isAssignableFrom

    public boolean isAssignableFrom(Class cls)

  Determines if the class or interface represented by this `Class` object is either the same as, or is a superclass or superinterface of, the class or interface represented by the specified `Class` parameter. It returns `true` if so; otherwise it returns `false`. If this `Class` object represents a primitive type, this method returns `true` if the specified `Class` parameter is exactly this `Class` object; otherwise it returns `false`.

  Specifically, this method tests whether the type represented by the specified `Class` parameter can be converted to the type represented by this `Class` object via an identity conversion or via a widening reference conversion. See The Java Language Specification, sections 5.1.1 and 5.1.4 , for details.

  Parameters:
    `cls` - the `Class` object to be checked
  Returns:
    the `boolean` value indicating whether objects of the type `cls` can be assigned to objects of this class
  Throws:
    `NullPointerException` - if the specified Class parameter is null.
  Since:
    JDK1.1

### isInterface

    public boolean isInterface()

  Determines if the specified `Class` object represents an interface type.

  Returns:
    `true` if this object represents an interface; `false` otherwise.

### isArray

    public boolean isArray()

  Determines if this `Class` object represents an array class.

  Returns:
    `true` if this object represents an array class; `false` otherwise.
  Since:
    JDK1.1

### isPrimitive

    public boolean isPrimitive()

  Determines if the specified `Class` object represents a primitive type.

  There are nine predefined `Class` objects to represent the eight primitive types and void. These are created by the Java Virtual Machine, and have the same names as the primitive types that they represent, namely `boolean`, `byte`, `char`, `short`, `int`, `long`, `float`, and `double`.

  These objects may only be accessed via the following public static final variables, and are the only `Class` objects for which this method returns `true`.

  Returns:
    true if and only if this class represents a primitive type
  Since:
    JDK1.1
  See Also:
    `Boolean.TYPE`, `Character.TYPE`, `Byte.TYPE`, `Short.TYPE`, `Integer.TYPE`, `Long.TYPE`, `Float.TYPE`, `Double.TYPE`, `Void.TYPE`

### getName

    public String getName()

  Returns the name of the entity (class, interface, array class, primitive type, or void) represented by this `Class` object, as a `String`.

  If this class object represents a reference type that is not an array type then the binary name of the class is returned, as specified by the Java Language Specification, Second Edition.

  If this class object represents a primitive type or void, then the name returned is a `String` equal to the Java language keyword corresponding to the primitive type or void.

  If this class object represents a class of arrays, then the internal form of the name consists of the name of the element type preceded by one or more '`[`' characters representing the depth of the array nesting. The encoding of element type names is as follows:

  > Element Type | Encoding
  > --- | ---
  > boolean | Z
  > byte | B
  > char | C
  > class or interface | Lclassname;
  > double | D
  > float | F
  > int | I
  > long | J
  > short | S

  The class or interface name classname is the binary name of the class specified above.

  Examples:

  >      String.class.getName()
  >          returns "java.lang.String"
  >      byte.class.getName()
  >          returns "byte"
  >      (new Object[3]).getClass().getName()
  >          returns "[Ljava.lang.Object;"
  >      (new int[3][4][5][6][7][8][9]).getClass().getName()
  >          returns "[[[[[[[I"

  Returns:
    the name of the class or interface represented by this object.

### getClassLoader

    public ClassLoader getClassLoader()

  Returns the class loader for the class. Some implementations may use null to represent the bootstrap class loader. This method will return null in such implementations if this class was loaded by the bootstrap class loader.

  If a security manager is present, and the caller's class loader is not null and the caller's class loader is not the same as or an ancestor of the class loader for the class whose class loader is requested, then this method calls the security manager's `checkPermission` method with a `RuntimePermission("getClassLoader")` permission to ensure it's ok to access the class loader for the class.

  If this object represents a primitive type or void, null is returned.

  Returns:
    the class loader that loaded the class or interface represented by this object.
  Throws:
    `SecurityException` - if a security manager exists and its `checkPermission` method denies access to the class loader for the class.
  See Also:
    `ClassLoader`, `SecurityManager.checkPermission(java.security.Permission)`, `RuntimePermission`

### getSuperclass

    public Class getSuperclass()

  Returns the `Class` representing the superclass of the entity (class, interface, primitive type or void) represented by this `Class`. If this `Class` represents either the `Object` class, an interface, a primitive type, or void, then null is returned. If this object represents an array class then the `Class` object representing the `Object` class is returned.

  Returns:
    the superclass of the class represented by this object.

### getPackage

    public Package getPackage()

  Gets the package for this class. The class loader of this class is used to find the package. If the class was loaded by the bootstrap class loader the set of packages loaded from CLASSPATH is searched to find the package of the class. Null is returned if no package object was created by the class loader of this class.

  Packages have attributes for versions and specifications only if the information was defined in the manifests that accompany the classes, and if the class loader created the package instance with the attributes from the manifest.

  Returns:
    the package of the class, or null if no package information is available from the archive or codebase.

### getInterfaces

    public Class[] getInterfaces()

  Determines the interfaces implemented by the class or interface represented by this object.

  If this object represents a class, the return value is an array containing objects representing all interfaces implemented by the class. The order of the interface objects in the array corresponds to the order of the interface names in the `implements` clause of the declaration of the class represented by this object. For example, given the declaration:

  >      class Shimmer implements FloorWax, DessertTopping { ... }

  suppose the value of `s` is an instance of `Shimmer`; the value of the expression:

  >      s.getClass().getInterfaces()[0]

  is the `Class` object that represents interface `FloorWax`; and the value of:

  >      s.getClass().getInterfaces()[1]

  is the `Class` object that represents interface `DessertTopping`.

  If this object represents an interface, the array contains objects representing all interfaces extended by the interface. The order of the interface objects in the array corresponds to the order of the interface names in the `extends` clause of the declaration of the interface represented by this object.

  If this object represents a class or interface that implements no interfaces, the method returns an array of length 0.

  If this object represents a primitive type or void, the method returns an array of length 0.

  Returns:
    an array of interfaces implemented by this class.

### getComponentType

    public Class getComponentType()

  Returns the `Class` representing the component type of an array. If this class does not represent an array class this method returns null.

  Returns:
    the `Class` representing the component type of this class if this class is an array
  Since:
    JDK1.1
  See Also:
    `Array`

### getModifiers

    public int getModifiers()

  Returns the Java language modifiers for this class or interface, encoded in an integer. The modifiers consist of the Java Virtual Machine's constants for `public`, `protected`, `private`, `final`, `static`, `abstract` and `interface`; they should be decoded using the methods of class `Modifier`.

  If the underlying class is an array class, then its `public`, `private` and `protected` modifiers are the same as those of its component type. If this `Class` represents a primitive type or void, its `public` modifier is always `true`, and its `protected` and `private` modifiers are always `false`. If this object represents an array class, a primitive type or void, then its `final` modifier is always `true` and its interface modifier is always `false`. The values of its other modifiers are not determined by this specification.

  The modifier encodings are defined in The Java Virtual Machine Specification, table 4.1.

  Returns:
    the `int` representing the modifiers for this class
  Since:
    JDK1.1
  See Also:
    `Modifier`

### getSigners

    public Object[] getSigners()

  Gets the signers of this class.

  Returns:
    the signers of this class, or null if there are no signers. In particular, this method returns null if this object represents a primitive type or void.
  Since:
    JDK1.1

### getDeclaringClass

    public Class getDeclaringClass()

  If the class or interface represented by this `Class` object is a member of another class, returns the `Class` object representing the class in which it was declared. This method returns null if this class or interface is not a member of any other class. If this `Class` object represents an array class, a primitive type, or void,then this method returns null.

  Returns:
    the declaring class for this class
  Since:
    JDK1.1

### getClasses

    public Class[] getClasses()

  Returns an array containing `Class` objects representing all the public classes and interfaces that are members of the class represented by this `Class` object. This includes public class and interface members inherited from superclasses and public class and interface members declared by the class. This method returns an array of length 0 if this `Class` object has no public member classes or interfaces. This method also returns an array of length 0 if this `Class` object represents a primitive type, an array class, or void.

  For this class and each of its superclasses, the following security checks are performed: If there is a security manager, the security manager's `checkMemberAccess` method is called with `this` and `Member.PUBLIC` as its arguments, where `this` is this class or the superclass whose members are being determined. If the class is in a package, then the security manager's `checkPackageAccess` method is also called with the package name as its argument. Either of these calls could result in a SecurityException.

  Returns:
    the array of `Class` objects representing the public members of this class
  Throws:
    `SecurityException` - if access to the information is denied.
  Since:
    JDK1.1
  See Also:
    `SecurityManager.checkMemberAccess(Class, int)`, `SecurityManager.checkPackageAccess(String)`

### getFields

    public Field[] getFields()
                      throws SecurityException

  Returns an array containing `Field` objects reflecting all the accessible public fields of the class or interface represented by this `Class` object. The elements in the array returned are not sorted and are not in any particular order. This method returns an array of length 0 if the class or interface has no accessible public fields, or if it represents an array class, a primitive type, or void.

  Specifically, if this `Class` object represents a class, this method returns the public fields of this class and of all its superclasses. If this `Class` object represents an interface, this method returns the fields of this interface and of all its superinterfaces.

  If there is a security manager, this method first calls the security manager's `checkMemberAccess` method with `this` and `Member.PUBLIC` as its arguments. If the class is in a package, then this method also calls the security manager's `checkPackageAccess` method with the package name as its argument. Either of these calls could result in a SecurityException.

  The implicit length field for array class is not reflected by this method. User code should use the methods of class `Array` to manipulate arrays.

  See The Java Language Specification, sections 8.2 and 8.3.

  Returns:
    the array of `Field` objects representing the public fields
  Throws:
    `SecurityException` - if access to the information is denied.
  Since:
    JDK1.1
  See Also:
    `Field`, `SecurityManager.checkMemberAccess(Class, int)`, `SecurityManager.checkPackageAccess(String)`

### getMethods

    public Method[] getMethods()
                        throws SecurityException

  Returns an array containing `Method` objects reflecting all the public member methods of the class or interface represented by this `Class` object, including those declared by the class or interface and and those inherited from superclasses and superinterfaces. The elements in the array returned are not sorted and are not in any particular order. This method returns an array of length 0 if this `Class` object represents a class or interface that has no public member methods, or if this `Class` object represents an array class, primitive type, or void.

  If there is a security manager, this method first calls the security manager's `checkMemberAccess` method with `this` and `Member.PUBLIC` as its arguments. If the class is in a package, then this method also calls the security manager's `checkPackageAccess` method with the package name as its argument. Either of these calls could result in a SecurityException.

  The class initialization method `<clinit>` is not included in the returned array. If the class declares multiple public member methods with the same parameter types, they are all included in the returned array.

  See The Java Language Specification, sections 8.2 and 8.4.

  Returns:
    the array of `Method` objects representing the public methods of this class
  Throws:
    `SecurityException` - if access to the information is denied.
  Since:
    JDK1.1
  See Also:
    `Method`, `SecurityManager.checkMemberAccess(Class, int)`, `SecurityManager.checkPackageAccess(String)`

### getConstructors

    public Constructor[] getConstructors()
                                  throws SecurityException

  Returns an array containing `Constructor` objects reflecting all the public constructors of the class represented by this `Class` object. An array of length 0 is returned if the class has no public constructors, or if the class is an array class, or if the class reflects a primitive type or void.

  If there is a security manager, this method first calls the security manager's `checkMemberAccess` method with `this` and `Member.PUBLIC` as its arguments. If the class is in a package, then this method also calls the security manager's `checkPackageAccess` method with the package name as its argument. Either of these calls could result in a SecurityException.

  Returns:
    the array containing `Method` objects for all the declared public constructors of this class matches the specified `parameterTypes`
  Throws:
    `SecurityException` - if access to the information is denied.
  Since:
    JDK1.1
  See Also:
    `Constructor`, `SecurityManager.checkMemberAccess(Class, int)`, `SecurityManager.checkPackageAccess(String)`

### getField

    public Field getField(String name)
                   throws NoSuchFieldException,
                          SecurityException

  Returns a `Field` object that reflects the specified public member field of the class or interface represented by this `Class` object. The `name` parameter is a `String` specifying the simple name of the desired field.

  If there is a security manager, this method first calls the security manager's `checkMemberAccess` method with `this` and `Member.PUBLIC` as its arguments. If the class is in a package, then this method also calls the security manager's `checkPackageAccess` method with the package name as its argument. Either of these calls could result in a SecurityException.

  The field to be reflected is determined by the algorithm that follows. Let C be the class represented by this object:

  1. If C declares a public field with the name specified, that is the field to be reflected.
  2. If no field was found in step 1 above, this algorithm is applied recursively to each direct superinterface of C. The direct superinterfaces are searched in the order they were declared.
  3. If no field was found in steps 1 and 2 above, and C has a superclass S, then this algorithm is invoked recursively upon S. If C has no superclass, then a `NoSuchFieldException` is thrown.

  See The Java Language Specification, sections 8.2 and 8.3.

  Parameters:
    `name` - the field name
  Returns:
    the `Field` object of this class specified by `name`
  Throws:
    `NoSuchFieldException` - if a field with the specified name is not found.
    `NullPointerException` - if `name` is `null`
    `SecurityException` - if access to the information is denied.
  Since:
    JDK1.1
  See Also:
    `Field`, `SecurityManager.checkMemberAccess(Class, int)`, `SecurityManager.checkPackageAccess(String)`

### getMethod

    public Method getMethod(String name,
                            Class[] parameterTypes)
                     throws NoSuchMethodException,
                            SecurityException

  Returns a `Method` object that reflects the specified public member method of the class or interface represented by this `Class` object. The `name` parameter is a `String` specifying the simple name the desired method. The `parameterTypes` parameter is an array of `Class` objects that identify the method's formal parameter types, in declared order. If `parameterTypes` is `null`, it is treated as if it were an empty array.

  If there is a security manager, this method first calls the security manager's `checkMemberAccess` method with `this` and `Member.PUBLIC` as its arguments. If the class is in a package, then this method also calls the security manager's `checkPackageAccess` method with the package name as its argument. Either of these calls could result in a SecurityException.

  If the `name` is "<init>"or "<clinit>" a `NoSuchMethodException` is raised. Otherwise, the method to be reflected is determined by the algorithm that follows. Let C be the class represented by this object:

  1. C is searched for any matching methods. If no matching method is found, the algorithm of step 1 is invoked recursively on the superclass of C.
  2. If no method was found in step 1 above, the superinterfaces of C are searched for a matching method. If any such method is found, it is reflected.
  To find a matching method in a class C: If C declares exactly one public method with the specified name and exactly the same formal parameter types, that is the method reflected. If more than one such method is found in C, and one of these methods has a return type that is more specific than any of the others, that method is reflected; otherwise one of the methods is chosen arbitrarily.

  See The Java Language Specification, sections 8.2 and 8.4.

  Parameters:
    `name` - the name of the method
    `parameterTypes` - the list of parameters
  Returns:
    the `Method` object that matches the specified `name` and `parameterTypes`
  Throws:
    `NoSuchMethodException` - if a matching method is not found or if the name is "<init>"or "<clinit>".
    `NullPointerException` - if `name` is `null`
    `SecurityException` - if access to the information is denied.
  Since:
    JDK1.1
  See Also:
    `Method`, `SecurityManager.checkMemberAccess(Class, int)`, `SecurityManager.checkPackageAccess(String)`

### getConstructor

    public Constructor getConstructor(Class[] parameterTypes)
                               throws NoSuchMethodException,
                                      SecurityException

  Returns a `Constructor` object that reflects the specified public constructor of the class represented by this `Class` object. The `parameterTypes` parameter is an array of `Class` objects that identify the constructor's formal parameter types, in declared order.

  The constructor to reflect is the public constructor of the class represented by this `Class` object whose formal parameter types match those specified by `parameterTypes`.

  If there is a security manager, this method first calls the security manager's `checkMemberAccess` method with `this` and `Member.PUBLIC` as its arguments. If the class is in a package, then this method also calls the security manager's `checkPackageAccess` method with the package name as its argument. Either of these calls could result in a SecurityException.

  Parameters:
    `parameterTypes` - the parameter array
  Returns:
    the `Method` object of the public constructor that matches the specified `parameterTypes`
  Throws:
    `NoSuchMethodException` - if a matching method is not found.
    `SecurityException` - if access to the information is denied.
  Since:
    JDK1.1
  See Also:
    `Constructor`, `SecurityManager.checkMemberAccess(Class, int)`, `SecurityManager.checkPackageAccess(String)`

### getDeclaredClasses

    public Class[] getDeclaredClasses()
                               throws SecurityException

  Returns an array of `Class` objects reflecting all the classes and interfaces declared as members of the class represented by this `Class` object. This includes public, protected, default (package) access, and private classes and interfaces declared by the class, but excludes inherited classes and interfaces. This method returns an array of length 0 if the class declares no classes or interfaces as members, or if this `Class` object represents a primitive type, an array class, or void.

  If there is a security manager, this method first calls the security manager's `checkMemberAccess` method with `this` and `Member.DECLARED` as its arguments. If the class is in a package, then this method also calls the security manager's `checkPackageAccess` method with the package name as its argument. Either of these calls could result in a SecurityException.

  Returns:
    the array of `Class` objects representing all the declared members of this class
  Throws:
    `SecurityException` - if access to the information is denied.
  Since:
    JDK1.1
  See Also:
    `SecurityManager.checkMemberAccess(Class, int)`, `SecurityManager.checkPackageAccess(String)`

### getDeclaredFields

    public Field[] getDeclaredFields()
                              throws SecurityException

  Returns an array of `Field` objects reflecting all the fields declared by the class or interface represented by this `Class` object. This includes public, protected, default (package) access, and private fields, but excludes inherited fields. The elements in the array returned are not sorted and are not in any particular order. This method returns an array of length 0 if the class or interface declares no fields, or if this `Class` object represents a primitive type, an array class, or void.

  See The Java Language Specification, sections 8.2 and 8.3.

  If there is a security manager, this method first calls the security manager's `checkMemberAccess` method with `this` and `Member.DECLARED` as its arguments. If the class is in a package, then this method also calls the security manager's `checkPackageAccess` method with the package name as its argument. Either of these calls could result in a SecurityException.

  Returns:
    the array of `Field` objects representing all the declared fields of this class
  Throws:
    `SecurityException` - if access to the information is denied.
  Since:
    JDK1.1
  See Also:
    `Field`, `SecurityManager.checkMemberAccess(Class, int)`, `SecurityManager.checkPackageAccess(String)`

### getDeclaredMethods

    public Method[] getDeclaredMethods()
                                throws SecurityException

  Returns an array of `Method` objects reflecting all the methods declared by the class or interface represented by this `Class` object. This includes public, protected, default (package) access, and private methods, but excludes inherited methods. The elements in the array returned are not sorted and are not in any particular order. This method returns an array of length 0 if the class or interface declares no methods, or if this `Class` object represents a primitive type, an array class, or void. The class initialization method `<clinit>` is not included in the returned array. If the class declares multiple public member methods with the same parameter types, they are all included in the returned array.

  See The Java Language Specification, section 8.2.

  If there is a security manager, this method first calls the security manager's `checkMemberAccess` method with `this` and `Member.DECLARED` as its arguments. If the class is in a package, then this method also calls the security manager's `checkPackageAccess` method with the package name as its argument. Either of these calls could result in a SecurityException.

  Returns:
    the array of `Method` objects representing all the declared methods of this class
  Throws:
    `SecurityException` - if access to the information is denied.
  Since:
    JDK1.1
  See Also:
    `Method`, `SecurityManager.checkMemberAccess(Class, int)`, `SecurityManager.checkPackageAccess(String)`

### getDeclaredConstructors

    public Constructor[] getDeclaredConstructors()
                                          throws SecurityException

  Returns an array of `Constructor` objects reflecting all the constructors declared by the class represented by this `Class` object. These are public, protected, default (package) access, and private constructors. The elements in the array returned are not sorted and are not in any particular order. If the class has a default constructor, it is included in the returned array. This method returns an array of length 0 if this `Class` object represents an interface, a primitive type, an array class, or void.

  See The Java Language Specification, section 8.2.

  If there is a security manager, this method first calls the security manager's `checkMemberAccess` method with `this` and `Member.DECLARED` as its arguments. If the class is in a package, then this method also calls the security manager's `checkPackageAccess` method with the package name as its argument. Either of these calls could result in a SecurityException.

  Returns:
    the array of `Method` objects representing all the declared constructors of this class
  Throws:
    `SecurityException` - if access to the information is denied.
  Since:
    JDK1.1
  See Also:
    `Constructor`, `SecurityManager.checkMemberAccess(Class, int)`, `SecurityManager.checkPackageAccess(String)`

### getDeclaredField

    public Field getDeclaredField(String name)
                           throws NoSuchFieldException,
                                  SecurityException

  Returns a `Field` object that reflects the specified declared field of the class or interface represented by this `Class` object. The `name` parameter is a `String` that specifies the simple name of the desired field. Note that this method will not reflect the `length` field of an array class.

  If there is a security manager, this method first calls the security manager's `checkMemberAccess` method with `this` and `Member.DECLARED` as its arguments. If the class is in a package, then this method also calls the security manager's `checkPackageAccess` method with the package name as its argument. Either of these calls could result in a SecurityException.

  Parameters:
    `name` - the name of the field
  Returns:
    the `Field` object for the specified field in this class
  Throws:
    `NoSuchFieldException` - if a field with the specified name is not found.
    `NullPointerException` - if `name` is `null`
    `SecurityException` - if access to the information is denied.
  Since:
    JDK1.1
  See Also:
    `Field`, `SecurityManager.checkMemberAccess(Class, int)`, `SecurityManager.checkPackageAccess(String)`

### getDeclaredMethod

    public Method getDeclaredMethod(String name,
                                    Class[] parameterTypes)
                             throws NoSuchMethodException,
                                    SecurityException

  Returns a `Method` object that reflects the specified declared method of the class or interface represented by this `Class` object. The `name` parameter is a `String` that specifies the simple name of the desired method, and the `parameterTypes` parameter is an array of `Class` objects that identify the method's formal parameter types, in declared order. If more than one method with the same parameter types is declared in a class, and one of these methods has a return type that is more specific than any of the others, that method is returned; otherwise one of the methods is chosen arbitrarily. If the name is "<init>"or "<clinit>" a `NoSuchMethodException` is raised.

  If there is a security manager, this method first calls the security manager's `checkMemberAccess` method with `this` and `Member.DECLARED` as its arguments. If the class is in a package, then this method also calls the security manager's `checkPackageAccess` method with the package name as its argument. Either of these calls could result in a SecurityException.

  Parameters:
    `name` - the name of the method
    `parameterTypes` - the parameter array
  Returns:
    the `Method` object for the method of this class matching the specified name and parameters
  Throws:
    `NoSuchMethodException` - if a matching method is not found.
    `NullPointerException` - if `name` is `null`
    `SecurityException` - if access to the information is denied.
  Since:
    JDK1.1
  See Also:
    `Method`, `SecurityManager.checkMemberAccess(Class, int)`, `SecurityManager.checkPackageAccess(String)`

### getDeclaredConstructor

    public Constructor getDeclaredConstructor(Class[] parameterTypes)
                                       throws NoSuchMethodException,
                                              SecurityException

  Returns a `Constructor` object that reflects the specified constructor of the class or interface represented by this `Class` object. The `parameterTypes` parameter is an array of `Class` objects that identify the constructor's formal parameter types, in declared order.

  If there is a security manager, this method first calls the security manager's `checkMemberAccess` method with `this` and `Member.DECLARED` as its arguments. If the class is in a package, then this method also calls the security manager's `checkPackageAccess` method with the package name as its argument. Either of these calls could result in a SecurityException.

  Parameters:
    `parameterTypes` - the parameter array
  Returns:
    The `Method` object for the constructor with the specified parameter list
  Throws:
    `NoSuchMethodException` - if a matching method is not found.
    `SecurityException` - if access to the information is denied.
  Since:
    JDK1.1
  See Also:
    `Constructor`, `SecurityManager.checkMemberAccess(Class, int)`, `SecurityManager.checkPackageAccess(String)`

### getResourceAsStream

    public InputStream getResourceAsStream(String name)

  Finds a resource with a given name. This method returns null if no resource with this name is found. The rules for searching resources associated with a given class are implemented by the defining class loader of the class.

  This method delegates the call to its class loader, after making these changes to the resource name: if the resource name starts with "/", it is unchanged; otherwise, the package name is prepended to the resource name after converting "." to "/". If this object was loaded by the bootstrap loader, the call is delegated to `ClassLoader.getSystemResourceAsStream`.

  Parameters:
    `name` - name of the desired resource
  Returns:
    a `java.io.InputStream` object.
  Throws:
    `NullPointerException` - if `name` is `null`.
  Since:
    JDK1.1
  See Also:
    `ClassLoader`

### getResource

    public URL getResource(String name)

  Finds a resource with a given name. This method returns null if no resource with this name is found. The rules for searching resources associated with a given class are implemented by the * defining class loader of the class.

  This method delegates the call to its class loader, after making these changes to the resource name: if the resource name starts with "/", it is unchanged; otherwise, the package name is prepended to the resource name after converting "." to "/". If this object was loaded by the bootstrap loader, the call is delegated to `ClassLoader.getSystemResource`.

  Parameters:
    `name` - name of the desired resource
  Returns:
    a `java.net.URL` object.
  Since:
    JDK1.1
  See Also:
    `ClassLoader`

### getProtectionDomain

    public ProtectionDomain getProtectionDomain()

  Returns the `ProtectionDomain` of this class. If there is a security manager installed, this method first calls the security manager's `checkPermission` method with a `RuntimePermission("getProtectionDomain")` permission to ensure it's ok to get the `ProtectionDomain`.

  Returns:
    the ProtectionDomain of this class
  Throws:
    `SecurityException` - if a security manager exists and its `checkPermission` method doesn't allow getting the ProtectionDomain.
  Since:
    1.2
  See Also:
    `ProtectionDomain`, `SecurityManager.checkPermission(java.security.Permission)`, `RuntimePermission`

### desiredAssertionStatus

    public boolean desiredAssertionStatus()

  Returns the assertion status that would be assigned to this class if it were to be initialized at the time this method is invoked. If this class has had its assertion status set, the most recent setting will be returned; otherwise, if any package default assertion status pertains to this class, the most recent setting for the most specific pertinent package default assertion status is returned; otherwise, if this class is not a system class (i.e., it has a class loader) its class loader's default assertion status is returned; otherwise, the system class default assertion status is returned.

  Few programmers will have any need for this method; it is provided for the benefit of the JRE itself. (It allows a class to determine at the time that it is initialized whether assertions should be enabled.) Note that this method is not guaranteed to return the actual assertion status that was (or will be) associated with the specified class when it was (or will be) initialized.

  Returns:
    the desired assertion status of the specified class.
  Since:
    1.4
  See Also:
    `ClassLoader.setClassAssertionStatus(java.lang.String, boolean)`, `ClassLoader.setPackageAssertionStatus(java.lang.String, boolean)`, `ClassLoader.setDefaultAssertionStatus(boolean)`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.2
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Copyright 2003 Sun Microsystems, Inc. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.